#include "widget.h"
#include "ui_widget.h"
#include "Algorithms.h"

Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);

    //Do not input point nor polygon
    input_point = false;
    input_polygon = false;

    //Initialize test point
    q.setX(-10);
    q.setY(-10);

    //Set links
    ui->widget->setPolygon(&p);
    ui->widget->setPoint(&q);
}

Widget::~Widget()
{
    delete ui;
}

void Widget::mouseMoveEvent(QMouseEvent *e)
{
    //Print actual coordinates
    ui->label_2->setText(QString::number(e->pos().x()));
    ui->label_3->setText(QString::number(e->pos().y()));
}

void Widget::mousePressEvent(QMouseEvent *e)
{
    //Add polygon point
    if (input_polygon)
    {
        p.addPoint(Point(e->pos().x(), e->pos().y()));
    }

    //Set coordinates of the point
    else if (input_point)
    {
        q.setX(e->pos().x());
        q.setY(e->pos().y());
    }

    //Update canvas
    ui->widget->update();

    //Print actual coordinates
    ui->label_2->setText(QString::number(e->pos().x()));
    ui->label_3->setText(QString::number(e->pos().y()));
}


void Widget::on_pushButton_2_clicked()
{
    //Input point
    input_polygon = true;
    input_point = false;

}

void Widget::on_pushButton_3_clicked()
{
    //Input polygon
    input_point = true;
    input_polygon = false;
}


void Widget::on_pushButton_clicked()
{
    //Test point, polygon should have >=3 points
    if (p.getSize() > 2)
    {
       
    }
}

void Widget::on_pushButton_4_clicked()
{
    //Clear polygon
    p.clear();

    //Update canvas
    ui->widget->update();
}



void Widget::on_pushButton_5_clicked()
{
    //Test point, polygon should have >=3 points
    if (p.getSize() > 2)
    {

    }

}
